---
title: user-select
slug: Web/CSS/user-select
tags:
  - CSS
  - CSS Property
  - Property
  - Reference
  - Selection
  - 'recipe:css-property'
  - user-select
---
<div>{{CSSRef}}</div>

<p>The <code><strong>user-select</strong></code> <a href="/en-US/docs/Web/CSS">CSS</a> property controls whether the user can select text. This doesn't have any effect on content loaded as {{Glossary("Chrome", "chrome")}}, except in textboxes.</p>

<pre class="brush:css notranslate">/* Keyword values */
user-select: none;
user-select: auto;
user-select: text;
user-select: contain;
user-select: all;

/* Global values */
user-select: inherit;
user-select: initial;
user-select: unset;

/* Mozilla-specific values */
-moz-user-select: none;
-moz-user-select: text;
-moz-user-select: all;

/* WebKit-specific values */
-webkit-user-select: none;
-webkit-user-select: text;
-webkit-user-select: all; /* Doesn't work in Safari; use only
                             "none" or "text", or else it will
                             allow typing in the &lt;html&gt; container */

/* Microsoft-specific values */
-ms-user-select: none;
-ms-user-select: text;
-ms-user-select: element;
</pre>

<div class="notecard note">
<p><strong>Note</strong>: <code>user-select</code> is not an inherited property, though the initial <code>auto</code> value makes it behave like it is inherited most of the time. WebKit/Chromium-based browsers <em>do</em> implement the property as inherited, which violates the behavior described in the spec, and this will bring some issues. Until now, Chromium chooses to <a class="external external-icon" href="https://chromium.googlesource.com/chromium/src/+/b01af0b296ecb855aac95c4ed335d188e6eac2de" rel="noopener">fix the issues</a>, make the final behavior meets the specifications.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<dl>
	<dt><code>none</code></dt>
	<dd>The text of the element and its sub-elements is not selectable. Note that the {{domxref("Selection")}} object can contain these elements.</dd>
	<dt><code>auto</code></dt>
	<dd>
	<p>The used value of <code>auto</code> is determined as follows:</p>

	<ul>
		<li>On the <code>::before</code> and <code>::after</code> pseudo elements, the used value is <code>none</code></li>
		<li>If the element is an editable element, the used value is <code>contain</code></li>
		<li>Otherwise, if the used value of <code>user-select</code> on the parent of this element is <code>all</code>, the used value is <code>all</code></li>
		<li>Otherwise, if the used value of <code>user-select</code> on the parent of this element is <code>none</code>, the used value is <code>none</code></li>
		<li>Otherwise, the used value is <code>text</code></li>
	</ul>
	</dd>
	<dt><code>text</code></dt>
	<dd>The text can be selected by the user.</dd>
	<dt><code>all</code></dt>
	<dd>The content of the element shall be selected atomically: If a selection would contain part of the element, then the selection must contain the entire element including all its descendants.  If a double-click or context-click occurred in sub-elements, the highest ancestor with this value will be selected.</dd>
	<dt><code>contain</code></dt>
	<dd>Enables selection to start within the element; however, the selection will be contained by the bounds of that element.</dd>
	<dt><code>element</code>{{non-standard_inline}} (IE-specific alias)</dt>
	<dd>Same as <code>contain</code>. Supported only in Internet Explorer.</dd>
</dl>

<div class="note">
<p><strong>Note:</strong> CSS UI 4 <a href="https://github.com/w3c/csswg-drafts/commit/3f1d9db96fad8d9fc787d3ed66e2d5ad8cfadd05">renames <code>user-select: element</code> to <code>contain</code></a>.</p>
</div>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p&gt;You should be able to select this text.&lt;/p&gt;
&lt;p class="unselectable"&gt;Hey, you can't select this text!&lt;/p&gt;
&lt;p class="all"&gt;Clicking once will select all of this text.&lt;/p&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">.unselectable {
  -moz-user-select: none;
  -webkit-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

.all {
  -moz-user-select: all;
  -webkit-user-select: all;
  -ms-user-select: all;
  user-select: all;
}
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Examples")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('CSS4 UI', '#propdef-user-select', 'user-select')}}</td>
			<td>{{Spec2('CSS4 UI')}}</td>
			<td>Initial definition. Also defines <code>-webkit-user-select</code> as a deprecated alias of <code>user-select</code>.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("css.properties.user-select")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{Cssxref("::selection")}} pseudo-element</li>
	<li>The JavaScript {{domxref("Selection")}} object</li>
</ul>
